Subject: Re: [PATCH net] net: batman-adv: Fix possible memleaks when fail to register_netdevice

From: Sven Eckelmann <[email-masked]>
Date: Tue, 25 Apr 2017 15:53:19 +0200

On Dienstag, 25. April 2017 20:03:20 CEST [email-masked] wrote:
> From: Gao Feng <[email-masked]>
> 
> Because the func batadv_softif_init_late allocate some resources and
> it would be invoked in register_netdevice. So we need to invoke the
> func batadv_softif_free instead of free_netdev to cleanup when fail
> to register_netdevice.

I could be wrong, but shouldn't the destructor be replaced with free_netdevice 
and the batadv_softif_free (without the free_netdev) used as ndo_uninit? The 
line you've changed should then be kept as free_netdevice.

At least this seems to be important when using rtnl_newlink() instead of the 
legacy sysfs netdev stuff from batman-adv. rtnl_newlink() would also only call 
free_netdevice and thus also not run batadv_softif_free. This seems to be only 
fixable by calling ndo_uninit.

Kind regards,
	Sven